/*
 * Copyright 2022 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

object Plugins {

  object BuildPlugins {
    const val androidLib = "com.android.library"
    const val application = "com.android.application"
    // Use Dokka 1.6.10 until https://github.com/Kotlin/dokka/issues/2452 is resolved.
    const val dokka = "org.jetbrains.dokka"
    const val kotlin = "kotlin"
    const val kotlinAndroid = "kotlin-android"
    const val kotlinKapt = "kotlin-kapt"
    const val mavenPublish = "maven-publish"
    const val navSafeArgs = "androidx.navigation.safeargs.kotlin"
    const val ruler = "com.spotify.ruler"
    const val spotless = "com.diffplug.spotless"
  }

  // classpath plugins
  const val androidGradlePlugin = "com.android.tools.build:gradle:${Versions.androidGradlePlugin}"
  const val kotlinGradlePlugin =
    "org.jetbrains.kotlin:kotlin-gradle-plugin:${Dependencies.Versions.Kotlin.stdlib}"
  const val navSafeArgsGradlePlugin =
    "androidx.navigation:navigation-safe-args-gradle-plugin:${Dependencies.Versions.Androidx.navigation}"
  const val rulerGradlePlugin = "com.spotify.ruler:ruler-gradle-plugin:1.2.1"

  object Versions {
    const val androidGradlePlugin = "7.2.1"
    // Use Dokka 1.6.10 until https://github.com/Kotlin/dokka/issues/2472 is resolved.
    const val dokka = "1.6.10"
  }
}
